import sys

from jax.config import config
config.update("jax_enable_x64", True)
import matplotlib
import numpy as np
from scipy import stats
matplotlib.use('Agg')
import matplotlib.pyplot as plt
import pickle
import importlib
import matplotlib.cm as cm
import visualise_lj
from jax import random
import jax.numpy as jnp
from datetime import datetime
from scipy.spatial import ConvexHull
import matplotlib.ticker as ticker
import dimmer_utils
import func_utils
import potentials_2d
import dimmer
import opt_algorithms
importlib.reload(potentials_2d)
importlib.reload(func_utils)
importlib.reload(dimmer_utils)
importlib.reload(dimmer)



# file_name="../lj7_1p/lj7_prms.pickle"
file_name="../lj7_1/lj7_prms.pickle"
file = open(file_name, 'rb')
fs=1


prms=pickle.load(file)
file.close()
prms,V,V_plot,x_s, y_s, l_s,X0,limits=potentials_2d.setup_problem(prms)
T=np.int32(prms.T_real/prms.h_x)
Nd=prms.N_a*prms.d
debug_file=False
make_alg_plot=True
is_plain = True
total_i1=11
index1=np.zeros(total_i1)
# all TS points found
index1[0]=-11.03733448
index1[1]=-10.93522342
index1[2] =-10.91978916
index1[3]= -10.89848533
index1[4]= -10.79874588
index1[5]=-11.0402529
index1[6]=-10.80730445
index1[7]=-10.84132249
index1[8]=-10.88257484
index1[9]=-10.77139919
index1[10]=-10.79803943
index1= jnp.sort(index1)

print("all index1=",index1)

if make_alg_plot:
    plt.figure(figsize=(400, 400))
    plt.rcParams.update({'font.size': 6})
    plt.rc('xtick', labelsize=6)
    plt.rc('ytick', labelsize=6)
    fig, axs = plt.subplots(1, 1)
    axs = [axs]
    max_iter =1000
    # axs[0].set(xlim=(0, max_iter * 10), ylim=(-11.1, -10.75))
    axs[0].set(xlim=(0, max_iter * 10), ylim=(0, total_i1+1))
    for i in range(1, total_i1+1):
        # axs[0].axhline(index1[i], 0, 10 * max_iter, zorder=1, alpha=0.5, color='grey')
        axs[0].axhline(i, 0, 10 * max_iter, zorder=1, alpha=0.5, color='grey')
    for fs in range(2,max_iter):
        # print(fs)
        file_x = open(prms.str_file + "x_stats_" + str(fs) + ".pickle", "rb")
        [out_s, t, X_t, Y_t, wgts, run_dimmer, S_card] = pickle.load(file_x)
        file_d = open(prms.str_file + "d_stats_" + str(fs) + ".pickle", "rb")

        U_0, t, exit_code, dimmer_iters, x_index1, x_final=pickle.load(file_d)
        if is_plain:
            x_final=[x_final]
        V_m,dV_s,ddV_s,dV,hvp_vec,ddV,index_func_lambda,index_func_lambda_map,gd_map=func_utils.get_func_evals(V,prms)
        succeed, U_index1 = dimmer_utils.find_unique_index1_points(x_final, V_m, dV, ddV, index_func_lambda_map, prms.eig_eps, prms.eig_gap, prms.dimmer_eps)
        if succeed:
            values=(V_m(U_index1))
            number_points=len(values)
            for kk in range(0,number_points):
                idx = (np.abs(index1 - values[kk])).argmin()
                axs[0].scatter(10*fs,1+idx,s=5,zorder=5,color='r')
            #
            fname = "../debug/consensus_dimer_lj7_1.svg"
            plt.savefig(fname, dpi=300)
            print(fs,dimmer_iters,number_points,values)
            max_diff=10e-12
            for i in range(0,number_points):
                diff_i=np.min(np.abs(index1-values[0]))
                if diff_i>max_diff:
                    max_diff=diff_i
                if max_diff>10e-8:
                    print('new=',values)
                    # sys.exit(-1)
        else:
            print(fs, "Fail")

if debug_file:
    fs=35
    idx=5


    prms, V, V_plot, x_s, y_s, l_s, X0, limits = potentials_2d.setup_problem(prms)
    plt.rcParams.update({'font.size': 3})
    plt.rc('xtick', labelsize=6)
    plt.rc('ytick', labelsize=6)
    plt.figure(figsize=(1200, 1200))
    fig, axs = plt.subplots(2, 3)
    for i in range(0, 2):
        for j in range(0, 3):
            axs[i, j].set(xlim=(-3, 3), ylim=(-3, 3))
            axs[i, j].set_aspect('equal', 'box')
    fig.tight_layout()
    colors = cm.gist_rainbow(np.linspace(0, 1, prms.N_a))

    file_x = open(prms.str_file + "x_stats_" + str(fs) + ".pickle", "rb")
    file_d = open(prms.str_file + "d_stats_" + str(fs) + ".pickle", "rb")
    [out_s, t, X_t, Y_t, wgts, run_dimmer, S_card] = pickle.load(file_x)
    U_0, t, exit_code, dimmer_iters, x_index1, x_final = pickle.load(file_d)
    if is_plain:
        x_final=[x_final]
    V_m, dV_s, ddV_s, dV, hvp_vec, ddV, index_func_lambda, index_func_lambda_map, gd_map = func_utils.get_func_evals(V, prms)
    succeed, U_index1 = dimmer_utils.find_unique_index1_points(x_final, V_m, dV, ddV, index_func_lambda_map, prms.eig_eps, prms.eig_gap, prms.dimmer_eps)
    # if is_plain:
    #     U_index1=[U_index1]
    f_value = (V(U_index1[idx]))
    print(fs,V_m(U_index1))
    print(idx,f_value)
    total_d=prms.N_a*prms.d
    # intial configuarion
    dv_norm_0, hess_eval, mu_0, v_0 = visualise_lj.get_stats(X0, dV_s, ddV_s, total_d)
    axs[0, 0] = visualise_lj.plot_2dLJ(X0, prms, axs[0, 0], colors, t=0, fEval=V(X0), grad_norm=dv_norm_0, first_egv=mu_0[0], first_pos=mu_0[1 + prms.eig_gap])
    axs[0, 0].set_xlabel('Initial Point-X0')
    # # dimmer inital point -- average U_0

    if is_plain:
        avg_U0 = U_0

    else:
        avg_U0 = jnp.mean(U_0, axis=0)
    dv_norm_u0, hess_eval, mu_u0, v_u0 = visualise_lj.get_stats(avg_U0, dV_s, ddV_s, total_d)
    axs[0, 1] = visualise_lj.plot_2dLJ(avg_U0, prms, axs[0, 1], colors, t=t, fEval=V(avg_U0), grad_norm=dv_norm_u0, first_egv=mu_u0[0], first_pos=mu_u0[1 + prms.eig_gap])
    axs[0, 1].set_xlabel('Dimer Avg Initial Point-U0')
    # # initial point basin of attraction
    prms.gd_max_iter=5000
    prms.gd_dt=0.001
    prms.basin_gd_tol=10e-5
    success, x_k, vEval, dVNorm = opt_algorithms.gd_vanilla(V, dV_s, prms.gd_dt, prms.gd_max_iter, prms.basin_gd_tol, avg_U0)
    if success is False:
        print("Basin GD falied")
    dv_norm_xk, hess_eval, mu_xk, v_xk = visualise_lj.get_stats(x_k, dV_s, ddV_s, total_d)
    axs[1, 0] = visualise_lj.plot_2dLJ(x_k, prms, axs[1, 0], colors, t=0, fEval=V(x_k), grad_norm=dv_norm_xk, first_egv=mu_xk[0], first_pos=mu_xk[1 + prms.eig_gap])
    opt_dist=-1
    diff_x0=jnp.linalg.norm(x_k-X0)
    str_title = 'GD(U0) - U_m,hg dist.={:<0.3f},l2 dist.={:<0.3f}'.format(opt_dist, diff_x0)
    axs[1, 0].set_xlabel(str_title)
    #
    # saddle point
    x_index1=U_index1[idx]
    dv_norm_x_index1, hess_eval, mu_x_index1, v_x_index1 = visualise_lj.get_stats(x_index1, dV_s, ddV_s, total_d)
    axs[1, 1] = visualise_lj.plot_2dLJ(x_index1, prms, axs[1, 1], colors, t=0, fEval=V(x_index1), grad_norm=dv_norm_x_index1, first_egv=mu_x_index1[0], first_pos=mu_x_index1[1 + prms.eig_gap])
    axs[1, 1].set_xlabel('Dimer Final Point-UT')
    #
    # # find minimum after a positive perturbation
    # dtau=0.0001
    dtau=0.15
    d_nudge = dtau * (V(X0) - V(x_index1)) * (v_x_index1[:, 0]).reshape(prms.N_a, prms.d)
    X_plus = x_index1 + d_nudge
    X_minus = x_index1 - d_nudge
    # prms.gd_dt=0.0001
    # prms.gd_max_iter=50000
    success_p, x_plus, vEval_plus, dVNorm_plus = opt_algorithms.gd_vanilla(V, dV_s, prms.gd_dt, prms.gd_max_iter, prms.basin_gd_tol, X_plus)
    success_m, x_minus, vEval_minus, dVNorm_minus = opt_algorithms.gd_vanilla(V, dV_s, prms.gd_dt, prms.gd_max_iter, prms.basin_gd_tol, X_minus)
    if (success_p or success_m) is False:
        print(success_p,success_m,"Perturbation GD falied")
    dv_norm_plus, hess_eval, mu_x_plus, v_x_plus = visualise_lj.get_stats(x_plus, dV_s, ddV_s, total_d)
    axs[0, 2] = visualise_lj.plot_2dLJ(x_plus, prms, axs[0, 2], colors, t=0, fEval=vEval_plus, grad_norm=dv_norm_plus, first_egv=mu_x_plus[0], first_pos=mu_x_plus[1 + prms.eig_gap])
    axs[0, 2].set_xlabel('GD(UT+Nudge)')

    dv_norm_minus, hess_eval, mu_x_minus, v_x_minus = visualise_lj.get_stats(x_minus, dV_s, ddV_s, total_d)
    axs[1, 2] = visualise_lj.plot_2dLJ(x_minus, prms, axs[1, 2], colors, t=0, fEval=vEval_minus, grad_norm=dv_norm_minus, first_egv=mu_x_minus[0], first_pos=mu_x_minus[1 + prms.eig_gap])
    axs[1, 2].set_xlabel('GD(UT-Nudge)')
    
    plt.savefig(prms.str_file + "C1-"+str(fs) +"-"+str(idx)+ ".svg", dpi=600, format='svg')

    # dist_adj_mat_map,scale_adj_mat_map,dot_product_dimmermap,mult_dimmermap = dimmer_utils.setup_particle_dimmer()
    # key = random.PRNGKey(prms.seed)
    # prms.eig_eps=1e-12
    # prms.dimmer_dt=0.001
    # prms.dimmer_max_iter=1000
    # prms.S=100
    # S_card, U, U_0 = dimmer_utils.find_best_particles(X_t, wgts.W, dV, ddV, prms.eig_eps, prms.S, prms.N_p, Nd, index_func_lambda_map, prms.best_particle)
    #
    # debug_dimmer=False
    # succeed=False
    # exit_code,dimmer_iters,x_index1,x_final=dimmer.particle_ideal_dimmer(prms,key,U,V_m,dV,ddV,index_func_lambda_map,dist_adj_mat_map,scale_adj_mat_map,dot_product_dimmermap,mult_dimmermap,debug_dimmer)
    # # grad_t = dV(x_final)
    # # dv_norm = jnp.linalg.norm(grad_t.reshape(S_card, Nd), axis=1)
    # # V_m(x_final)
    # prms.eig_eps=10e-12



    # prms.eig_eps=1e-2
    # prms.eig_gap=3
    # S_card, U, U_0 = dimmer_utils.find_best_particles(X_t, wgts.W, dV, ddV, prms.eig_eps,prms.eig_gap, prms.S, prms.N_p, Nd, index_func_lambda_map,prms.best_particle)
    # print(fs,S_card)
    # for ii in range(0,S_card):
    #      # ii=1
    #     exit_code, dimmer_iters, x_index1, x_final = \
    #     dimmer.ideal_dimmer(U[ii], V, dV_s, ddV_s, beta=2.0, dt=prms.dimmer_dt, eig_eps=prms.eig_eps, eps=prms.dimmer_eps, max_iter=prms.dimmer_max_iter, eig_gap=prms.eig_gap)
    #     if exit_code==0:
    #         hess_eval = ddV_s(x_final).reshape(14,14)
    #         dv_norm= jnp.linalg.norm(dV_s(x_final))
    #         eigval,eigvec = jnp.linalg.eigh(hess_eval)
    #         print("\t",ii + 1, ",", S_card, ",", exit_code, ",", dimmer_iters, ",", V(x_final),eigval[0:5],dv_norm, flush=True)

    # if make_iter_plot or make_final_plot :
    #     plt.figure(figsize=(400, 400))
    #     plt.rcParams.update({'font.size': 6})
    #     plt.rc('xtick', labelsize=6)
    #     plt.rc('ytick', labelsize=6)
    #     fig, axs = plt.subplots(1,1)
    #     axs=[axs]
    #     x_min,x_max,y_min,y_max=limits[0], limits[1],limits[2], limits[3]
    #     axs[0].set(xlim=(x_min, x_max), ylim=(y_min, y_max))
    #     axs[0].set_aspect('equal', 'box')
    #     x = np.arange(x_min, x_max, h)
    #     y = np.arange(y_min, y_max, h)
    #     X, Y = np.meshgrid(x, y)
    #     Vgrid=V_plot(X,Y)
    #
    #     if make_iter_plot:
    #         for iter_fs in range(1,dimmer_iters,1000):
    #             file = open("../debug/particle_dimer_" + str(iter_fs) + ".pickle", "rb")
    #             t,U_t,lap_mat=pickle.load(file)
    #             fname = "../debug/particle_dimer_" + str(iter_fs) + ".png"
    #             axs[0].contour(X, Y, Vgrid, levels=20, cmap=plt.cm.coolwarm, zorder=10, linestyles='-')
    #             axs[0].scatter(U_t[:, 0, 0], U_t[:, 0, 1], cmap=plt.cm.coolwarm, s=15, zorder=5)
    #             if succeed:
    #                 axs[0].scatter(x_index1[:,0,0], x_index1[:, 0, 1],c='g', s=1, zorder=1)
    #
    #             print(iter_fs,fname)
    #             plt.savefig(fname, dpi=300)
    #             axs[0].clear()
    #     else:
    #         axs[0].contour(X, Y, Vgrid, levels=20, cmap=plt.cm.coolwarm, zorder=10, linestyles='-')
    #         if len(x_final.shape)>2:
    #             axs[0].scatter(x_final[:, 0, 0], x_final[:, 0, 1], cmap=plt.cm.coolwarm, s=15, zorder=5)
    #             if succeed:
    #                 axs[0].scatter(x_index1[:, 0, 0], x_index1[:, 0, 1], c='g', s=50, zorder=1)
    #         else:
    #             axs[0].scatter(x_final[0, 0], x_final[0, 1], cmap=plt.cm.coolwarm, s=15, zorder=5)
    #             if succeed:
    #                 axs[0].scatter(x_index1[ 0, 0], x_index1[ 0, 1], c='g', s=50, zorder=1)
    #         fname = "../debug/particle_dimer"+str(fs)+".png"
    #         print("save:",fname)
    #         plt.savefig(fname, dpi=300)
# dimmer_iters, x_d, V_d, exit_code, norm_d, eigval_d, eigvec_d = \
#     dimmer.ideal_dimmer(U_0, V, dV_s, ddV_s, beta=2.0, dt=prms.dimmer_dt, eig_eps=prms.eig_eps, eps=prms.dimmer_eps, max_iter=prms.dimmer_max_iter)
# print(dimmer_iters,exit_code,norm_d,eigval_d)

